<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\ContenutoBacheca;
use App\DataTables\ContenutoBachecaDataTable;
use App\DataTables\ContenutoBachecaDataTableEditor;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;

class ContenutoBachecaController extends Controller
{
    public static $permission_group = "Contenuto Bacheca";
    public static $permissions = [
        'view-contenuto_bacheca' => 'Vedi',
        'create-contenuto_bacheca' => 'Crea',
        'edit-contenuto_bacheca' => 'Modifica',
        'delete-contenuto_bacheca' => 'Elimina',
    ];
    
    public static function middleware(): array
    {
        return [
            new Middleware('permission:view-contenuto_bacheca', only: ['index']),
            new Middleware('permission:create-contenuto_bacheca|edit-contenuto_bacheca|delete-contenuto_bacheca', only: ['store', 'update', 'destroy']),
        ];
    }
    
    public function index(ContenutoBachecaDataTable $dataTable)
    {
        $dataTable->attivita_id = Session::get('attivita_attuale');
        return $dataTable->render('contenuto_bacheca.index');
    }
    
    public function store(ContenutoBachecaDataTableEditor $editor)
    {
        $request = request();
        $input = $request->all();
        if($request->has('action')){
            switch($input['action']){
                case 'create':
                    if(!Auth::user()->can('create-contenuto_bacheca')) return;
                    break;
                case 'edit':
                    if(!Auth::user()->can('edit-contenuto_bacheca')) return;
                    break;
                case 'delete':
                    if(!Auth::user()->can('delete-contenuto_bacheca')) return;
                    break;
            }
        }
        return $editor->process($request);
    }
    
    public function show(Request $request)
    {
        $contenuto_bacheca = ContenutoBacheca::find($request->get('contenuto_bacheca_id'));
        return view('contenuto_bacheca.show', ['contenuto_bacheca' => $contenuto_bacheca]);
    }
    
}

